/*----- PROTECTED REGION ID(E2SextupoleClass.cpp) ENABLED START -----*/
/* clang-format on */
//=============================================================================
//
// file :        E2SextupoleClass.cpp
//
// description : C++ source for the E2SextupoleClass.
//               A singleton class derived from DeviceClass.
//               It implements the command and attribute list
//               and all properties and methods required
//               by the E2Sextupole once per process.
//
// project :     Elettra 2.0 pure corrector magnet device
//
// This file is part of Tango device class.
//
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
//
//
// Elettra - Sincrotrone Trieste S.c.p.A.
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#include "E2SextupoleClass.h"
/* clang-format off */
/*----- PROTECTED REGION END -----*/	//	E2SextupoleClass.cpp

//-------------------------------------------------------------------
/**
 *	Create E2SextupoleClass singleton and
 *	return it in a C function for Python usage
 */
//-------------------------------------------------------------------
extern "C" {
#ifdef _TG_WINDOWS_

__declspec(dllexport)

#endif

	Tango::DeviceClass *_create_E2Sextupole_class(const char *name) {
		return E2Sextupole_ns::E2SextupoleClass::init(name);
	}
}

namespace E2Sextupole_ns
{
//===================================================================
//	Initialize pointer for singleton pattern
//===================================================================
E2SextupoleClass *E2SextupoleClass::_instance = NULL;

//===================================================================
//	Class constants
//===================================================================
//--------------------------------------------------------
/**
 * method : 		E2SextupoleClass::E2SextupoleClass(std::string &s)
 * description : 	constructor for the E2SextupoleClass
 *
 * @param s	The class name
 */
//--------------------------------------------------------
E2SextupoleClass::E2SextupoleClass(std::string &s):Tango::DeviceClass(s)
{
	TANGO_LOG_INFO << "Entering E2SextupoleClass constructor" << std::endl;
	set_default_property();
	get_class_property();
	write_class_property();

	/*----- PROTECTED REGION ID(E2SextupoleClass::constructor) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	E2SextupoleClass::constructor

	TANGO_LOG_INFO << "Leaving E2SextupoleClass constructor" << std::endl;
}

//--------------------------------------------------------
/**
 * method : 		E2SextupoleClass::~E2SextupoleClass()
 * description : 	destructor for the E2SextupoleClass
 */
//--------------------------------------------------------
E2SextupoleClass::~E2SextupoleClass()
{
	/*----- PROTECTED REGION ID(E2SextupoleClass::destructor) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	E2SextupoleClass::destructor

	_instance = NULL;
}


//--------------------------------------------------------
/**
 * method : 		E2SextupoleClass::init
 * description : 	Create the object if not already done.
 *                  Otherwise, just return a pointer to the object
 *
 * @param	name	The class name
 */
//--------------------------------------------------------
E2SextupoleClass *E2SextupoleClass::init(const char *name)
{
	if (_instance == NULL)
	{
		try
		{
			std::string s(name);
			_instance = new E2SextupoleClass(s);
		}
		catch (std::bad_alloc &)
		{
			throw;
		}
	}
	return _instance;
}

//--------------------------------------------------------
/**
 * method : 		E2SextupoleClass::instance
 * description : 	Check if object already created,
 *                  and return a pointer to the object
 */
//--------------------------------------------------------
E2SextupoleClass *E2SextupoleClass::instance()
{
	if (_instance == NULL)
	{
		std::cerr << "Class is not initialized !!" << std::endl;
		exit(-1);
	}
	return _instance;
}



//===================================================================
//	Command execution method calls
//===================================================================
//--------------------------------------------------------
/**
 * method : 		ResetClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *ResetClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	TANGO_LOG_INFO << "ResetClass::execute(): arrived" << std::endl;
	((static_cast<E2Sextupole *>(device))->reset());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		ResetResonanceStrengthClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *ResetResonanceStrengthClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	TANGO_LOG_INFO << "ResetResonanceStrengthClass::execute(): arrived" << std::endl;
	((static_cast<E2Sextupole *>(device))->reset_resonance_strength());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		ApplyDesignStrengthClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *ApplyDesignStrengthClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	TANGO_LOG_INFO << "ApplyDesignStrengthClass::execute(): arrived" << std::endl;
	((static_cast<E2Sextupole *>(device))->apply_design_strength());
	return new CORBA::Any();
}


//===================================================================
//	Properties management
//===================================================================
//--------------------------------------------------------
/**
 *	Method     : E2SextupoleClass::get_class_property()
 *	Description: Get the class property for specified name.
 */
//--------------------------------------------------------
Tango::DbDatum E2SextupoleClass::get_class_property(std::string &prop_name)
{
	for (unsigned int i=0 ; i<cl_prop.size() ; i++)
		if (cl_prop[i].name == prop_name)
			return cl_prop[i];
	//	if not found, returns  an empty DbDatum
	return Tango::DbDatum(prop_name);
}

//--------------------------------------------------------
/**
 *	Method     : E2SextupoleClass::get_default_device_property()
 *	Description: Return the default value for device property.
 */
//--------------------------------------------------------
Tango::DbDatum E2SextupoleClass::get_default_device_property(std::string &prop_name)
{
	for (unsigned int i=0 ; i<dev_def_prop.size() ; i++)
		if (dev_def_prop[i].name == prop_name)
			return dev_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}

//--------------------------------------------------------
/**
 *	Method     : E2SextupoleClass::get_default_class_property()
 *	Description: Return the default value for class property.
 */
//--------------------------------------------------------
Tango::DbDatum E2SextupoleClass::get_default_class_property(std::string &prop_name)
{
	for (unsigned int i=0 ; i<cl_def_prop.size() ; i++)
		if (cl_def_prop[i].name == prop_name)
			return cl_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}

//--------------------------------------------------------
/**
 *	Method     : E2SextupoleClass::get_class_property()
 *	Description: Read database to initialize class property data members.
 */
//--------------------------------------------------------
void E2SextupoleClass::get_class_property()
{
	/*----- PROTECTED REGION ID(E2SextupoleClass::get_class_property_before) ENABLED START -----*/
	/* clang-format on */
	//	Initialize class property data members
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	E2SextupoleClass::get_class_property_before
	//	Read class properties from database.
	cl_prop.push_back(Tango::DbDatum("BeamEnergy"));
	cl_prop.push_back(Tango::DbDatum("CalibrationPath"));

	//	Call database and extract values
	if (Tango::Util::instance()->_UseDb==true)
		get_db_class()->get_property(cl_prop);
	Tango::DbDatum	def_prop;
	int	i = -1;

	//	Try to extract BeamEnergy value
	if (cl_prop[++i].is_empty()==false)	cl_prop[i]  >>  beamEnergy;
	else
	{
		//	Check default value for BeamEnergy
		def_prop = get_default_class_property(cl_prop[i].name);
		if (def_prop.is_empty()==false)
		{
			def_prop    >>  beamEnergy;
			cl_prop[i]  <<  beamEnergy;
		}
	}
	//	Try to extract CalibrationPath value
	if (cl_prop[++i].is_empty()==false)	cl_prop[i]  >>  calibrationPath;
	else
	{
		//	Check default value for CalibrationPath
		def_prop = get_default_class_property(cl_prop[i].name);
		if (def_prop.is_empty()==false)
		{
			def_prop    >>  calibrationPath;
			cl_prop[i]  <<  calibrationPath;
		}
	}
	/*----- PROTECTED REGION ID(E2SextupoleClass::get_class_property_after) ENABLED START -----*/
	/* clang-format on */
	//	Check class property data members init
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	E2SextupoleClass::get_class_property_after

}

//--------------------------------------------------------
/**
 *	Method     : E2SextupoleClass::set_default_property()
 *	Description: Set default property (class and device) for wizard.
 *                For each property, add to wizard property name and description.
 *                If default value has been set, add it to wizard property and
 *                store it in a DbDatum.
 */
//--------------------------------------------------------
void E2SextupoleClass::set_default_property()
{
	std::string	prop_name;
	std::string	prop_desc;
	std::string	prop_def;
	std::vector<std::string>	vect_data;

	//	Set Default Class Properties
	prop_name = "BeamEnergy";
	prop_desc = "default electron beam energy, in GeV.\nUse to initialize all magnet istances BeamEnergy attribute.";
	prop_def  = "2.4";
	vect_data.clear();
	vect_data.push_back("2.4");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		cl_def_prop.push_back(data);
		add_wiz_class_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_class_prop(prop_name, prop_desc);
	prop_name = "CalibrationPath";
	prop_desc = "path of calibration and parameter files";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		cl_def_prop.push_back(data);
		add_wiz_class_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_class_prop(prop_name, prop_desc);

	//	Set Default device Properties
	prop_name = "CurrentDevice";
	prop_desc = "power supply tango device name";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "Model";
	prop_desc = "corrector model (part number)";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "SerialNumber";
	prop_desc = "serial number of the magnet";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "MagnetName";
	prop_desc = "Name of magnet";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "CalibrationFileName";
	prop_desc = "name of calibration table file name";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "CalibrationPath";
	prop_desc = "path of calibration and parameter files";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "ParameterFileName";
	prop_desc = "name of auxiliary parametr file name\n(EBSmagnet compatibility)";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
}

//--------------------------------------------------------
/**
 *	Method     : E2SextupoleClass::write_class_property()
 *	Description: Set class description fields as property in database
 */
//--------------------------------------------------------
void E2SextupoleClass::write_class_property()
{
	//	First time, check if database used
	if (Tango::Util::_UseDb == false)
		return;

	Tango::DbData	data;
	std::string	classname = get_name();
	std::string	header;

	//	Put title
	Tango::DbDatum	title("ProjectTitle");
	std::string	str_title("Elettra 2.0 pure corrector magnet device");
	title << str_title;
	data.push_back(title);

	//	Put Description
	Tango::DbDatum	description("Description");
	std::vector<std::string>	str_desc;
	str_desc.push_back("Elettra 2.0 sextupole magnet device");
	str_desc.push_back("Use calibration table handle current/strgenght converstions.");
	str_desc.push_back("The magnet device is connected to a power supply tango device , real or simulated.");
	str_desc.push_back("");
	str_desc.push_back("Based on ESRF EBSmagnet concepts and libraries.");
	description << str_desc;
	data.push_back(description);

	//  Put inheritance
	Tango::DbDatum	inher_datum("InheritedFrom");
	std::vector<std::string> inheritance;
	inheritance.push_back("TANGO_BASE_CLASS");
	inher_datum << inheritance;
	data.push_back(inher_datum);

	//	Call database and and values
	get_db_class()->put_property(data);
}

//===================================================================
//	Factory methods
//===================================================================

//--------------------------------------------------------
/**
 *	Method     : E2SextupoleClass::device_factory()
 *	Description: Create the device object(s)
 *                and store them in the device list
 */
//--------------------------------------------------------
void E2SextupoleClass::device_factory(const Tango::DevVarStringArray *devlist_ptr)
{
	/*----- PROTECTED REGION ID(E2SextupoleClass::device_factory_before) ENABLED START -----*/
/* clang-format on */
//	Add your own code
/* clang-format off */
/*----- PROTECTED REGION END -----*/	//	E2SextupoleClass::device_factory_before

	//	Create devices and add it into the device list
	for (unsigned long i=0 ; i<devlist_ptr->length() ; i++)
	{
		TANGO_LOG_DEBUG << "Device name : " << (*devlist_ptr)[i].in() << std::endl;
		device_list.push_back(new E2Sextupole(this, (*devlist_ptr)[i]));
	}

	//	Manage dynamic attributes if any
	erase_dynamic_attributes(devlist_ptr, get_class_attr()->get_attr_list());

	//	Export devices to the outside world
	for (unsigned long i=1 ; i<=devlist_ptr->length() ; i++)
	{
		//	Add dynamic attributes if any
		E2Sextupole *dev = static_cast<E2Sextupole *>(device_list[device_list.size()-i]);
		dev->add_dynamic_attributes();

		//	Check before if database used.
		if ((Tango::Util::_UseDb == true) && (Tango::Util::_FileDb == false))
			export_device(dev);
		else
			export_device(dev, dev->get_name().c_str());
	}

	/*----- PROTECTED REGION ID(E2SextupoleClass::device_factory_after) ENABLED START -----*/
/* clang-format on */
//	Add your own code
/* clang-format off */
/*----- PROTECTED REGION END -----*/	//	E2SextupoleClass::device_factory_after
}
//--------------------------------------------------------
/**
 *	Method     : E2SextupoleClass::attribute_factory()
 *	Description: Create the attribute object(s)
 *                and store them in the attribute list
 */
//--------------------------------------------------------
void E2SextupoleClass::attribute_factory(std::vector<Tango::Attr *> &att_list)
{
	/*----- PROTECTED REGION ID(E2SextupoleClass::attribute_factory_before) ENABLED START -----*/
	/* clang-format on */
	//	Add your own code
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	E2SextupoleClass::attribute_factory_before
	//	Attribute : Strength
	StrengthAttrib	*strength = new StrengthAttrib();
	Tango::UserDefaultAttrProp	strength_prop;
	strength_prop.set_description("sextupole strength 1/m^3 ( m-3)");
	strength_prop.set_label("strength");
	strength_prop.set_unit("m-3");
	//	standard_unit	not set for Strength
	//	display_unit	not set for Strength
	//	format	not set for Strength
	//	max_value	not set for Strength
	//	min_value	not set for Strength
	//	max_alarm	not set for Strength
	//	min_alarm	not set for Strength
	//	max_warning	not set for Strength
	//	min_warning	not set for Strength
	//	delta_t	not set for Strength
	//	delta_val	not set for Strength
	strength->set_default_properties(strength_prop);
	//	Not Polled
	strength->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(strength);

	//	Attribute : CorrectionStrength
	CorrectionStrengthAttrib	*correctionstrength = new CorrectionStrengthAttrib();
	Tango::UserDefaultAttrProp	correctionstrength_prop;
	//	description	not set for CorrectionStrength
	correctionstrength_prop.set_label("correction strength");
	correctionstrength_prop.set_unit("m-3");
	//	standard_unit	not set for CorrectionStrength
	//	display_unit	not set for CorrectionStrength
	//	format	not set for CorrectionStrength
	//	max_value	not set for CorrectionStrength
	//	min_value	not set for CorrectionStrength
	//	max_alarm	not set for CorrectionStrength
	//	min_alarm	not set for CorrectionStrength
	//	max_warning	not set for CorrectionStrength
	//	min_warning	not set for CorrectionStrength
	//	delta_t	not set for CorrectionStrength
	//	delta_val	not set for CorrectionStrength
	correctionstrength->set_default_properties(correctionstrength_prop);
	//	Not Polled
	correctionstrength->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(correctionstrength);

	//	Attribute : ResonanceStrength
	ResonanceStrengthAttrib	*resonancestrength = new ResonanceStrengthAttrib();
	Tango::UserDefaultAttrProp	resonancestrength_prop;
	//	description	not set for ResonanceStrength
	resonancestrength_prop.set_label("resonance strength");
	resonancestrength_prop.set_unit("m-3");
	//	standard_unit	not set for ResonanceStrength
	//	display_unit	not set for ResonanceStrength
	//	format	not set for ResonanceStrength
	//	max_value	not set for ResonanceStrength
	//	min_value	not set for ResonanceStrength
	//	max_alarm	not set for ResonanceStrength
	//	min_alarm	not set for ResonanceStrength
	//	max_warning	not set for ResonanceStrength
	//	min_warning	not set for ResonanceStrength
	//	delta_t	not set for ResonanceStrength
	//	delta_val	not set for ResonanceStrength
	resonancestrength->set_default_properties(resonancestrength_prop);
	//	Not Polled
	resonancestrength->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(resonancestrength);

	//	Attribute : Current
	CurrentAttrib	*current = new CurrentAttrib();
	Tango::UserDefaultAttrProp	current_prop;
	//	description	not set for Current
	//	label	not set for Current
	current_prop.set_unit("A");
	//	standard_unit	not set for Current
	//	display_unit	not set for Current
	//	format	not set for Current
	//	max_value	not set for Current
	//	min_value	not set for Current
	//	max_alarm	not set for Current
	//	min_alarm	not set for Current
	//	max_warning	not set for Current
	//	min_warning	not set for Current
	//	delta_t	not set for Current
	//	delta_val	not set for Current
	current->set_default_properties(current_prop);
	//	Not Polled
	current->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(current);

	//	Attribute : BeamEnergy
	BeamEnergyAttrib	*beamenergy = new BeamEnergyAttrib();
	Tango::UserDefaultAttrProp	beamenergy_prop;
	beamenergy_prop.set_description("Electron beam energy in eV. Used to calculate magnetic rigidity in strength calculations.");
	beamenergy_prop.set_label("electron beam ebergy [eV]");
	//	unit	not set for BeamEnergy
	//	standard_unit	not set for BeamEnergy
	//	display_unit	not set for BeamEnergy
	//	format	not set for BeamEnergy
	//	max_value	not set for BeamEnergy
	//	min_value	not set for BeamEnergy
	//	max_alarm	not set for BeamEnergy
	//	min_alarm	not set for BeamEnergy
	//	max_warning	not set for BeamEnergy
	//	min_warning	not set for BeamEnergy
	//	delta_t	not set for BeamEnergy
	//	delta_val	not set for BeamEnergy
	beamenergy->set_default_properties(beamenergy_prop);
	//	Not Polled
	beamenergy->set_disp_level(Tango::EXPERT);
	//	Not Memorized
	att_list.push_back(beamenergy);

	//	Attribute : DesignStrength
	DesignStrengthAttrib	*designstrength = new DesignStrengthAttrib();
	Tango::UserDefaultAttrProp	designstrength_prop;
	designstrength_prop.set_description("sextupole design strength 1/m^3 ( m-3). The strenght reqiured by the nominal optic\nThe attribute is memorized , expert only.");
	designstrength_prop.set_label("design strength");
	designstrength_prop.set_unit("m-3");
	//	standard_unit	not set for DesignStrength
	//	display_unit	not set for DesignStrength
	//	format	not set for DesignStrength
	//	max_value	not set for DesignStrength
	//	min_value	not set for DesignStrength
	//	max_alarm	not set for DesignStrength
	//	min_alarm	not set for DesignStrength
	//	max_warning	not set for DesignStrength
	//	min_warning	not set for DesignStrength
	//	delta_t	not set for DesignStrength
	//	delta_val	not set for DesignStrength
	designstrength->set_default_properties(designstrength_prop);
	//	Not Polled
	designstrength->set_disp_level(Tango::EXPERT);
	designstrength->set_memorized();
	designstrength->set_memorized_init(true);
	att_list.push_back(designstrength);


	//	Create a list of static attributes
	create_static_attribute_list(get_class_attr()->get_attr_list());
	/*----- PROTECTED REGION ID(E2SextupoleClass::attribute_factory_after) ENABLED START -----*/
	/* clang-format on */
	//	Add your own code
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	E2SextupoleClass::attribute_factory_after
}
//--------------------------------------------------------
/**
 *	Method     : E2SextupoleClass::pipe_factory()
 *	Description: Create the pipe object(s)
 *                and store them in the pipe list
 */
//--------------------------------------------------------
void E2SextupoleClass::pipe_factory()
{
	/*----- PROTECTED REGION ID(E2SextupoleClass::pipe_factory_before) ENABLED START -----*/
	/* clang-format on */
	//	Add your own code
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	E2SextupoleClass::pipe_factory_before
	/*----- PROTECTED REGION ID(E2SextupoleClass::pipe_factory_after) ENABLED START -----*/
	/* clang-format on */
	//	Add your own code
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	E2SextupoleClass::pipe_factory_after
}
//--------------------------------------------------------
/**
 *	Method     : E2SextupoleClass::command_factory()
 *	Description: Create the command object(s)
 *                and store them in the command list
 */
//--------------------------------------------------------
void E2SextupoleClass::command_factory()
{
	/*----- PROTECTED REGION ID(E2SextupoleClass::command_factory_before) ENABLED START -----*/
	/* clang-format on */
	//	Add your own code
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	E2SextupoleClass::command_factory_before


	//	Command Reset
	ResetClass	*pResetCmd =
		new ResetClass("Reset",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pResetCmd);

	//	Command ResetResonanceStrength
	ResetResonanceStrengthClass	*pResetResonanceStrengthCmd =
		new ResetResonanceStrengthClass("ResetResonanceStrength",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pResetResonanceStrengthCmd);

	//	Command ApplyDesignStrength
	ApplyDesignStrengthClass	*pApplyDesignStrengthCmd =
		new ApplyDesignStrengthClass("ApplyDesignStrength",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pApplyDesignStrengthCmd);

	/*----- PROTECTED REGION ID(E2SextupoleClass::command_factory_after) ENABLED START -----*/
	/* clang-format on */
	//	Add your own code
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	E2SextupoleClass::command_factory_after
}

//===================================================================
//	Dynamic attributes related methods
//===================================================================

//--------------------------------------------------------
/**
 * method : 		E2SextupoleClass::create_static_attribute_list
 * description : 	Create the a list of static attributes
 *
 * @param	att_list	the created attribute list
 */
//--------------------------------------------------------
void E2SextupoleClass::create_static_attribute_list(std::vector<Tango::Attr *> &att_list)
{
	for (unsigned long i=0 ; i<att_list.size() ; i++)
	{
		std::string att_name(att_list[i]->get_name());
		std::transform(att_name.begin(), att_name.end(), att_name.begin(), ::tolower);
		defaultAttList.push_back(att_name);
	}

	TANGO_LOG_INFO << defaultAttList.size() << " attributes in default list" << std::endl;

	/*----- PROTECTED REGION ID(E2SextupoleClass::create_static_att_list) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	E2SextupoleClass::create_static_att_list
}


//--------------------------------------------------------
/**
 * method : 		E2SextupoleClass::erase_dynamic_attributes
 * description : 	delete the dynamic attributes if any.
 *
 * @param	devlist_ptr	the device list pointer
 * @param	list of all attributes
 */
//--------------------------------------------------------
void E2SextupoleClass::erase_dynamic_attributes(const Tango::DevVarStringArray *devlist_ptr, std::vector<Tango::Attr *> &att_list)
{
	Tango::Util *tg = Tango::Util::instance();

	for (unsigned long i=0 ; i<devlist_ptr->length() ; i++)
	{
		Tango::DeviceImpl *dev_impl = tg->get_device_by_name(((std::string)(*devlist_ptr)[i]).c_str());
		E2Sextupole *dev = static_cast<E2Sextupole *> (dev_impl);

		std::vector<Tango::Attribute *> &dev_att_list = dev->get_device_attr()->get_attribute_list();
		std::vector<Tango::Attribute *>::iterator ite_att;
		for (ite_att=dev_att_list.begin() ; ite_att != dev_att_list.end() ; ++ite_att)
		{
			std::string att_name((*ite_att)->get_name_lower());
			if ((att_name == "state") || (att_name == "status"))
				continue;
			std::vector<std::string>::iterator ite_str = find(defaultAttList.begin(), defaultAttList.end(), att_name);
			if (ite_str == defaultAttList.end())
			{
				TANGO_LOG_INFO << att_name << " is a UNWANTED dynamic attribute for device " << (*devlist_ptr)[i] << std::endl;
				Tango::Attribute &att = dev->get_device_attr()->get_attr_by_name(att_name.c_str());
				dev->remove_attribute(att_list[att.get_attr_idx()], true, false);
				--ite_att;
			}
		}
	}
	/*----- PROTECTED REGION ID(E2SextupoleClass::erase_dynamic_attributes) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	E2SextupoleClass::erase_dynamic_attributes
}

//--------------------------------------------------------
/**
 *	Method     : E2SextupoleClass::get_attr_object_by_name()
 *	Description: returns Tango::Attr * object found by name
 */
//--------------------------------------------------------
Tango::Attr *E2SextupoleClass::get_attr_object_by_name(std::vector<Tango::Attr *> &att_list, std::string attname)
{
	std::vector<Tango::Attr *>::iterator it;
	for (it=att_list.begin() ; it<att_list.end() ; ++it)
		if ((*it)->get_name()==attname)
			return (*it);
	//	Attr does not exist
	return NULL;
}


/*----- PROTECTED REGION ID(E2SextupoleClass::Additional Methods) ENABLED START -----*/
/* clang-format on */
/* clang-format off */
/*----- PROTECTED REGION END -----*/	//	E2SextupoleClass::Additional Methods
} //	namespace
